$! BUILD-ALPHA.COM
$!    Creates Ftnchek from source code for Alpha VMS systems
$!
$ On Control_Y Then GoTo The_Exit
$ On Warning Then GoTo The_Exit
$!
$!
$!   Now compile everything and link it all.  The /DEFINE is not actually
$!   needed since VMS is a predefined symbol in VAX C.
$!   If you have xmalloc/xrealloc, remove the /DEFINE from shell_mung
$!   line and add them to the list of objs to link.
$!   The CC.COM script is used in place of CC command so that if something
$!   is changed, BUILD-ALPHA can be re-run and only re-compiles what changed.
$!   Invocation: @CC PROG DEPENDENCIES [/CFLAGS...]
$ IF F$SEARCH("shell_mung.c") .EQS. ""
$ THEN!	If shell_mung not found, work around it and tell the user
$ WRITE SYS$OUTPUT "SHELL_MUNG.C not found: wildcard expansion will not be"
$ WRITE SYS$OUTPUT "done.  SHELL_MUNG.C is distributed separately."
$ @CC ftnchek ftnchek.h /STANDARD=VAXC/DEFINE=(VMS)
$ ELSE
$ @CC ftnchek ftnchek.h /STANDARD=VAXC/DEFINE=(VMS,USE_SHELL_MUNG)
$ @CC shell_mung "" /STANDARD=VAXC/DEFINE=("xmalloc=malloc","xrealloc=realloc")
$ ENDIF
$ @CC exprtype ftnchek.h,keywords.h,symtab.h,tokdefs.h /STANDARD=VAXC/DEFINE=(VMS)
$ @CC forlex ftnchek.h,symtab.h,tokdefs.h /STANDARD=VAXC/DEFINE=(VMS)
$ @CC fortran ftnchek.h,symtab.h,tokdefs.h /STANDARD=VAXC/DEFINE=(VMS)
$ @CC pgsymtab ftnchek.h,symtab.h /STANDARD=VAXC/DEFINE=(VMS)
$ @CC plsymtab ftnchek.h,symtab.h /STANDARD=VAXC/DEFINE=(VMS)
$ @CC project ftnchek.h,symtab.h /STANDARD=VAXC/DEFINE=(VMS)
$ @CC symtab ftnchek.h,iokeywds.h,intrins.h,symtab.h,tokdefs.h /STANDARD=VAXC/DEFINE=(VMS)
$ IF F$SEARCH("shell_mung.c") .EQS. ""
$ THEN
$ @LINK-ALPHA ftnchek,forlex,fortran,pgsymtab,plsymtab,symtab,exprtype,project
$ ELSE
$ @LINK-ALPHA ftnchek,forlex,fortran,pgsymtab,plsymtab,symtab,exprtype,project,shell_mung
$ ENDIF
$ Set NoVerify
$ WRITE SYS$OUTPUT "Ftnchek created"
$ WRITE SYS$OUTPUT "To make it runnable as a command"
$ WRITE SYS$OUTPUT "say   $ FTNCHEK :== $diskname:[pathname]FTNCHEK"
$ On Control_Y Then GoTo Help_Exit
$ On Warning Then GoTo Help_Exit
$! Create the help library.
$ LIBR/CREATE/HELP FTNCHEK.HLB FTNCHEK.HLP
$ WRITE SYS$OUTPUT "Help library created -- to access it via HELP"
$ WRITE SYS$OUTPUT "say   $ DEFINE HLP$LIBRARY diskname:[pathname]FTNCHEK.HLB"
$ EXIT
$ Help_Exit:
$ Set NoVerify
$ WRITE SYS$OUTPUT "Error- help library not created"
$ EXIT
$ The_Exit:
$ Set NoVerify
$ WRITE SYS$OUTPUT "Error- BUILD failed."
$ EXIT
$!From:	SMTP%"oppe@vs5.scri.fsu.edu" 17-SEP-1993 15:41:40.12
$!To:	MONIOT
$!CC:
$!Subj:	FTNCHEK 2.7 on DEC Alpha AXP running OpenVMS
$!
$!Date: Sun, 9 May 93 13:06:23 -0400
$!From: oppe@vs5.scri.fsu.edu (Thomas Oppe)
$!Message-Id: <9305091706.AA24710@vs5.scri.fsu.edu>
$!To: moniot@mary.fordham.edu
$!Subject: FTNCHEK 2.7 on DEC Alpha AXP running OpenVMS
$!
$!Dear Dr. Moniot,
$!
$!   FTNCHEK 2.7 now installs on a DEC Alpha AXP running OpenVMS with a
$!few changes to the BUILD.COM file.  Basically, I added
$!
$!    /STANDARD=VAXC/
$!
$!to the CC line and stripped out the VAXC.OPT and sharable library
$!commands.  Apparently, our Alphas did not have a VAXCRTL file.
$!Below is the revised BUILD.COM file and the output log from
$!running it.
$!
$!Tom Oppe
$!
