		/* These sizeofs are used in determining what kind of
		   int is needed to have enough bits to hold a flag
		   field.  It is OK for the sizes defined here to be
		   smaller than the true sizes: at worst it will just
		   use more space than necessary.  The generic version
		   uses values of 2, 4, 4 which should work fine on all
		   recent-vintage 32-bit machines.  */

#define SIZEOF_SHORT	2
#define SIZEOF_INT	4
#define SIZEOF_LONG	4

		/* Either memset or bzero is needed in forlex.c: memset
		   is preferred.
		 */
#define HAVE_MEMSET	1
#define HAVE_BZERO	0

		/* For Unix systems, the ftnpp filter program can be
		   built.  It relies on the system preprocessor for
		   macro expansions.  The path to this preprocessor must
		   be defined by macro CPP.
		*/
#ifndef CPP
#define CPP		"/lib/cpp"
#endif


